Loading...
Searching...
No Matches
nanoflann::PooledAllocator Class Reference
nanoflann C++ library for KD-trees » Memory allocation

`#include <nanoflann.hpp>`

## Public Member Functions

| PooledAllocator ()
| ~PooledAllocator ()
void | free_all ()
void * | malloc (const size_t req_size)
template<typename T>
T * | allocate (const size_t count=1)

## Public Attributes

Size | usedMemory = 0
Size | wastedMemory = 0

## Detailed Description

Pooled storage allocator

The following routines allow for the efficient allocation of storage in small chunks from a specified pool. Rather than allowing each structure to be freed individually, an entire pool of storage is freed at once. This method has two advantages over just using malloc() and free(). First, it is far more efficient for allocating small objects, as there is no overhead for remembering all the information needed to free each object or consolidating fragmented memory. Second, the decision about how long to keep an object is made at the time of allocation, and there is no need to track down all the objects to free them.

## Constructor & Destructor Documentation

## PooledAllocator()

nanoflann::PooledAllocator::PooledAllocator | ( |  | ) |

inline

Default constructor. Initializes a new pool.

## ~PooledAllocator()

nanoflann::PooledAllocator::~PooledAllocator | ( |  | ) |

inline

Destructor. Frees all the memory allocated in this pool.

## Member Function Documentation

## allocate()

template<typename T>

T * nanoflann::PooledAllocator::allocate | ( | const size_t | count = 1 | ) |

inline

Allocates (using this pool) a generic type T.

Params: count = number of instances to allocate. Returns: pointer (of type T*) to memory buffer

## free_all()

void nanoflann::PooledAllocator::free_all | ( |  | ) |

inline

Frees all allocated memory chunks

## malloc()

void * nanoflann::PooledAllocator::malloc | ( | const size_t | req_size | ) |

inline

Returns a pointer to a piece of new memory of the given size in bytes allocated from the pool.

The documentation for this class was generated from the following file:

- include/nanoflann.hpp